<?php

/**
 * Carerix Wordpress Plugin
 *
 * @category settings
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Aug 29, 2013 9:29:42 AM
 * @version $Rev$
 */

/**
 * Job class
 * Used to ....
 */
class Entity_Writer_Company extends Entity_Writer {
	
	protected $type = WP_Constants::ENTITY_TYPE_COMPANY;
	protected $fragment = '';
	
	public function getContent() 
	{
		$labels = Utils_Labels::get();
		$contentSections = array('companyInformation', 'visitAddress', 
			'visitPostalCode', 'phoneNumber', 'emailAddress', 'url');
		
		$labelKeyForSections = array(
			'companyInformation' => 'general.message.field.description',
			'visitAddress' => 'CxPortal.message.field.visitAddress',
			'visitPostalCode' => 'general.message.field.zipCode',
			'phoneNumber' => 'CxPortal.message.field.phoneGeneral',
			'emailAddress' => 'general.message.field.email',
			'url' => 'CxPortal.message.field.internetAddress',
		);
		
		$content = '';
		$set = false;
		
		foreach($contentSections as $section)
		{
			if(isset($this->dataDictionary[$section]))
			{
				$label_key = $labelKeyForSections[$section];
				$section_name = $labels[$label_key];
				
				$content .= "<h4 class='cx_h4'>$section_name</h4><p>{$this->dataDictionary[$section]}</p> ";
				if(!$set)
				{
					$this->fragment = $content;
					$content .= '<!--more-->';
					$set = true;
				}
			}
		}
		
		
		return $content;
	}

	public function getTitle() 
	{
		if(isset($this->dataDictionary['name']))
		{
			return $this->dataDictionary['name'];
		}
		
		return '';
	}
	
	public function getCorrespondentID()
	{
		if(isset($this->dataDictionary['id']))
		{
			return $this->dataDictionary['id'];
		}
		
		return false;
	}
	
	public function getPublishDate()
	{
		if(isset($this->dataDictionary['date']))
		{
			return $this->dataDictionary['date'];
		}
		
		return false;
	}
	
	public function getFragment($post_id)
	{
		$link = $this->interfacer->get_post_permalink($post_id);
		$content  = "<h2 class='cx_h2'><a href='$link'>".$this->getTitle()."</a></h2>";
		$content .= $this->fragment;
		return $content;
	}
	
	public function postWrite($post_id)
	{
            // set category
            $categories = array('Companies');
            $this->interfacer->entity_link_category($post_id, $categories);
	}

    public function getSlug() {
        return false;
    }
}