<?php

class Frontend_Shortcode
{
	/**
	 * @var array associative array consisting of keys as 'shortcodes' and 'fx' as functionname to bind
	 */
	protected $shortcodeDictionary = array();
	protected $dataDictionary = array();

	protected function register_shortcodes( $dataDictionary = array() )
	{
		foreach ($this->shortcodeDictionary as $shortcode => $item)
		{
			$fx = $item["fx"];
			$section_key = $item["section"] ?? "";

			add_shortcode( $shortcode,
				function ($attributes, $content, $shortcode_name) use ($fx, $section_key, $dataDictionary) {

					if ( $attributes === "" ) $attributes = array();
					// Utils_Log::info("\n 0: " . print_r($b, true) . "\n");
					$attributes['shortcode_name'] = $shortcode_name;
					$attributes['section_key'] = $section_key;

					return $this->$fx( $attributes, $content, $dataDictionary );
				}
			);
		}
	}
}