<?php

class Utils_Cache {

    static function _set_environment() {
        $cacheDirPath = Carerix::$TMPDIR . DIRECTORY_SEPARATOR . 'cache';

        if (!file_exists($cacheDirPath)) {
            mkdir($cacheDirPath, 0777, true);
        }
        return $cacheDirPath;
    }

    static function set($key, $value) {
        $cacheDirPath = self::_set_environment();
        $serialized = serialize($value);
        $filename = $key;
        file_put_contents($cacheDirPath . DIRECTORY_SEPARATOR . $filename, $serialized);
    }

    static function get($key) {
        $cacheDirPath = self::_set_environment();
        $file = $cacheDirPath . DIRECTORY_SEPARATOR . $key;

        if (file_exists($file)) {
            $content = file_get_contents($file);
            return unserialize($content);
        }
        return false;
    }

    static function cleanEnvironment() {
        $dirPath = self::_set_environment();
        $files = glob($dirPath . '/*');
        if ($files !== false) {
            foreach ($files as $file) {
                unlink($file);
            }
        }
    }

}
