<?php /** @noinspection PhpUndefinedVariableInspection */
/**
 * CV file upload and photo file upload
 * (Extra document is a 'repeatable' element and defined in repeatable_file.php)
 */


// imported from EmployeeApply.php as $data["varname"]
if(!isset($id)) $id = '';
if(!isset($label)) $label = '';
if(!isset($class_chain)) $class_chain = '';
if(!isset($name)) $name = '';
if(!isset($error)) $error = '';
if(!isset($value)) $value = '';
if(!isset($repeatable)) $repeatable = '';
$max_filesize = $max_filesize ?? '';
$max_filesize_bytes = $max_filesize_bytes ?? '';

$isRequired = (stripos($class_chain, 'required') !== FALSE) ? true : false;
// determine required class for label tag
$req_class_label = $isRequired ? " cx2_required" : "";

$labels = Utils_Labels::get();
global $dataindex;
$dataindex++;
if (!isset($container_class)) $container_class = "cx2_" . $id; // set default div classname
$class ='data_'.$dataindex;
if (isset($container_class)) {
	$class .= ' ' . $container_class;
}

list($group, $vname) = explode('-', $id);
$postedFileNotFound = false;
if(isset($_FILES[$group]['error'][$vname]) && $_FILES[$group]['error'][$vname] == 4) {
    $postedFileNotFound = true;
}
?>
<div class='<?php echo $class; ?>'>
<label for="<?php echo $id; ?>" class="cx2_<?php echo $id; ?><?php echo $req_class_label; ?>"><?php echo $label; ?></label>

<?php
    $kept = \Carerix\Cookie\Cookie::getCookie("kept", null, true);
    $_value = '';
    $type ='';
    if($value == '' )
    {
        $exploded = explode('-', $id);
        $type = $exploded[1];
        $section = $exploded[0];
        $on_disk_name = "{$type}_on_disk";

        if(isset($kept[$type.'_on_disk'])) {
            $_value = $kept[$type.'_on_disk'];
            $value = $kept[$type.'_to_display'];
            $uploaded_file_another_time_in_history_path = $uploadDirPath = Carerix::$TMPDIR . DIRECTORY_SEPARATOR . Utils_Log::UPLOADS_DIR_CONTAINER . DIRECTORY_SEPARATOR . $_value;
            if (!file_exists($uploaded_file_another_time_in_history_path)) { // The file (upload) is expired and removed from the server earlier
	            $postedFileNotFound = true;
            }
        }
    }

    if($postedFileNotFound) {
	    if (isset($kept[$type.'_on_disk'])) unset($kept[$type.'_on_disk']);
	    if (isset($kept[$type.'_to_display'])) unset($kept[$type.'_to_display']);
	    \Carerix\Cookie\Cookie::setCookie("kept", $kept);
    }

    $value = filter_var($value, FILTER_SANITIZE_SPECIAL_CHARS);
    $_value= filter_var($_value, FILTER_SANITIZE_SPECIAL_CHARS);

    if($_value && !$postedFileNotFound): ?>
        <input name="<?php echo $on_disk_name; ?>" value="<?php echo $_value; ?>" type="hidden" class="<?php echo $id; ?>_on_disk"/>
        <input readonly disabled class="<?php echo $class_chain; ?> <?php echo $id; ?>_to_display" type="text" id="<?php echo $id; ?>" data-index="0" data-maxsize="<?php echo $max_filesize_bytes; ?>" name="<?php echo $name; ?>" value="<?php echo $value; ?>" class="<?php echo $id; ?> to_display" />
        <a href="#" id="<?php echo $id; ?>_change"><?php echo $labels['CxWpPlugin.message.selectanotherfile'] ;?></a>
    <?php else: ?>
       <input <?php if(@$disabled) echo 'disabled'; ?> class="<?php echo $id; ?> <?php echo $class_chain; ?>" type="file" id="<?php echo $id; ?>" data-index="0" data-maxsize="<?php echo $max_filesize_bytes; ?>" name="<?php echo $name; ?>" value="<?php echo $value; ?>" />
    <?php endif; ?>

<span class="cx2_<?php echo $id ?>-info">
    <?php
    $message= '';
    switch($id):

        case 'personal-cv':
        case 'personal-coverLetter': // 'coverLetter' is a repeatable file (looks like it isn't used at all here)
            $message = $labels['CxPortal.message.info.allowedTypes'];
            break;
        case 'personal-photo':
            $message = $labels['CxPortal.message.info.allowedImageTypes'];
            break;
    endswitch;
    echo $message; ?>
    <b class="cx2_max_label"> (max <span class="cx2_max_filesize"><?php echo $max_filesize; ?></span> MB) </b>
</span>

<?php
if(strlen(trim($error))>0):
	echo "<div class='error'>$error</div>";
endif;
?>
</div>
<?php
$disabled = $disabled ? 'disabled' : '';
if($repeatable && !$disabled):
    echo '<a id="cx2_'.$id.'-add" data-index="'.$dataindex.'" href="#" data-repeats="'.$id.'" class="repeat '.$id.' '.$class.'"><i class="fa fa-plus"></i> '.$labels['general.button.add'].'</a>';
$style = 'display: none;';
if($value) $style = '';
echo '<a data-index="'.$dataindex.'" href="#" data-remove="'.$id.'" class="derepeat '.$id.' '.$class.'" style="'.$style.'"><i class="fa fa-minus"></i> '.$labels['general.button.remove'].'</a>';
endif;


global $CX_INIT_FILE_HANDLER_SINGLETON_IDS;
if (!isset($CX_INIT_FILE_HANDLER_SINGLETON_IDS)) $CX_INIT_FILE_HANDLER_SINGLETON_IDS = array();
$js                 = <<<EOT
   carerix_jQuery(document).ready(function(){
       var $ = carerix_jQuery;
       
       $('#{$id}_change').click(function(e){
            e.preventDefault();
            
            var the_id = '{$id}';
            var the_id_temp = '{$id}_temp';
            var file_input = $('<input class="{$class_chain}" type="file" id="'+the_id_temp+'" data-index="0" data-maxsize="{$max_filesize_bytes}" name="{$name}" value="{$value}" />') ;

            var \$parent = $('.'+the_id+'_to_display');
            \$parent.replaceWith(file_input);
            
            $('#'+the_id).remove();
            $('.'+the_id+'_to_display').remove();
            $('.'+the_id+'_on_disk').remove();
            $('#'+the_id+'_change').remove();
            $('#'+the_id_temp).attr('id',the_id);
            $(file_input).click();
            return false;
       });

   });
EOT;

if (!in_array($id, $CX_INIT_FILE_HANDLER_SINGLETON_IDS))
{
	wp_register_script( 'file-handle-footer', '', [], '', true );
	wp_enqueue_script( 'file-handle-footer'  );
	wp_add_inline_script("file-handle-footer", $js);
	$CX_INIT_FILE_HANDLER_SINGLETON_IDS[] = $id;
}
